#include <reg.h>
#include <stack.h>

/*-----MAIN------*/
MAIN:
// Set stack pointer
  lil       stkp,0x0000
  liu       stkp,0x00f0
// Set arg and put it on stack
  liu       gp,0x9876
  st        gp,0x10(stkp)
// Load gpr3  with a pointer to the argument
  addi      3,stkp,0x10
// Branch to showled function
  b SHOWLED
  nop
// Branch ad. infinitum
END:
  b END
  nop
/*===============*/
/*END OF FUNCTION*/

/*------SHOWLED------*/
SHOWLED:
// First store link register value
  mflr      gp
  st        gp,0x08(stkp)
// then change stkp
  stu       stkp,STKP_DECREMENT(stkp) 
// Now the stkp can be used to store all the registers
// we are about to overwrite.
  st        4,0x10(stkp)
  st        5,0x18(stkp)
  st        6,0x20(stkp)
// Obtain argument from *gpr3 to gp
  l         gp,0x0(3)
// load it to seg reg15 to what we want
  liu       5,0x8204
  oril      5,5,0x80
  mtsr      15,5
// Seg reg15 contains 0b10000010000001000000000010000000
// Set DT bit  (address trans on)
  mfmsr     5
  oril      6,5,0x10
  mtmsr     6
// Flush cache as memory context has just changed
// REM now we CANNOT access the stack or any pointers now
  ics
// write data to led address
  liu       4,0xF0A0
  st        gp,0x300(4)     
// Restore msr and seg15
  mtmsr     5
  xor       5,5,5
  mtsr      15,5
// Sync caches
  ics
  dcs
// Now we can access main mem again
// Re-instate registers
  l         4,0x10(stkp)
  l         5,0x18(stkp)
  l         6,0x20(stkp)
// Restore stkp
  ai        stkp,stkp,STKP_INCREMENT
// Load link register
  l         gp,0x08(stkp)
  mtlr      gp
// Return
  br

/*===============*/
/*END OF FUNCTION*/
