#include <reg.h>
#include <stack.h>

#define SYSTEM_INFO_OFFSET        0x278
#define POWER_KEY_STAT_REG_OFFSET 0x28

/*-----MAIN------*/
MAIN:
// Set stack pointer
  lil       stkp,0x0000
  liu       stkp,0x00f0
// Load iplcb_ptr onto stack
  st        3,0x20(stkp)    
// Load gp with system_into_ptr
KEY:
  l         3,0x20(stkp)
  l         gp,SYSTEM_INFO_OFFSET(3)
// Load gp with the power-key status register contents
  l         gp,POWER_KEY_STAT_REG_OFFSET(gp)
// AND gp with the key mask bits, 0x00000003
  addi      3,0,0x3
  and       4,gp,3

// See if gpr4 is normal, service or secure
  addi      3,0,0x02          // Load grp3 with service bits
  cmpl      0,4,3             // Compare in cr0
  liu       gp,0x1111         // Load gp with 0x1111
  st        gp,0x10(stkp)     // Put arg on stack
  addi      3,stkp,0x10       // Load gpr3 with pointer to arg
  beql      0,SHOWLED         // branch if condition was true
  addi      3,0,0x03          // load gpr3 with normal bits
  cmpl      0,4,3             // Compare in cr0
  liu       gp,0x2222         // Load gp with 0x2222
  st        gp,0x10(stkp)     // Put arg on stack
  addi      3,stkp,0x10       // Load gpr3 with pointer to arg
  beql      0,SHOWLED         // Branch if condition was true
// Branch ad. infinitum
END:
  b KEY
  nop
/*===============*/
/*END OF FUNCTION*/

/*------SHOWLED------*/
SHOWLED:
// First store link register value
  mflr      gp
  st        gp,0x08(stkp)
// then change stkp
  stu       stkp,STKP_DECREMENT(stkp) 
// Now the stkp can be used to store all the registers
// we are about to overwrite.
  st        4,0x10(stkp)
  st        5,0x18(stkp)
  st        6,0x20(stkp)
// Obtain argument from *gpr3 to gp
  l         gp,0x0(3)
// load it to seg reg15 to what we want
  liu       5,0x87F0
  oril      5,5,0xF
  mtsr      15,5
// Set DT bit  (address trans on)
  mfmsr     5
  oril      6,5,0x10
  mtmsr     6
// Flush cache as memory context has just changed
// REM now we CANNOT access the stack or any pointers now
  ics
// write to led address
  liu       4,0xff60
  st        gp,0x300(4)     
// Restore msr and seg15
  mtmsr     5
  xor       5,5,5
  mtsr      15,5
// Sync caches
  ics
  dcs
// Now we can access main mem again
// Re-instate registers
  l         4,0x10(stkp)
  l         5,0x18(stkp)
  l         6,0x20(stkp)
// Restore stkp
  ai        stkp,stkp,STKP_INCREMENT
// Load link register
  l         gp,0x08(stkp)
  mtlr      gp
// Return
  br

/*===============*/
/*END OF FUNCTION*/
