#include <reg.h>
#include <stack.h>

#define SYSTEM_INFO_OFFSET        0x278
#define POWER_KEY_STAT_REG_OFFSET 0x28

/*-----MAIN------*/
MAIN:
// Set stack pointer
  lil       stkp,0x0000
  liu       stkp,0x00f0
// Load iplcb_ptr onto stack

  lil       gp,0x6            // Load gp with 0x1111
  slwi      gp,gp,0x14
  st        gp,0x10(stkp)     // Put arg on stack
  addi      3,stkp,0x10       // Load gpr3 with pointer to arg
  bl        SHOWLED           // branch if condition was true
 
// Branch ad. infinitum
END:
  b END
  nop
/*===============*/
/*END OF FUNCTION*/

/*------SHOWLED------*/
SHOWLED:
// First store link register value
  mflr      gp
  st        gp,0x08(stkp)
// then change stkp
  stu       stkp,STKP_DECREMENT(stkp) 
// Now the stkp can be used to store all the registers
// we are about to overwrite.
  st        4,0x10(stkp)
  st        5,0x18(stkp)
  st        6,0x20(stkp)
// Obtain argument from *gpr3 to gp
  l         gp,0x0(3)
// load it to seg reg15 to what we want
  liu       5,0x87F0
  oril      5,5,0xF
  mtsr      15,5
// Set DT bit  (address trans on)
  mfmsr     5
  oril      6,5,0x10
  mtmsr     6
// Flush cache as memory context has just changed
// REM now we CANNOT access the stack or any pointers now
  ics
// write to led address
  liu       4,0xff60
  st        gp,0x300(4)     
// Restore msr and seg15
  mtmsr     5
  xor       5,5,5
  mtsr      15,5
// Sync caches
  ics
  dcs
// Now we can access main mem again
// Re-instate registers
  l         4,0x10(stkp)
  l         5,0x18(stkp)
  l         6,0x20(stkp)
// Restore stkp
  ai        stkp,stkp,STKP_INCREMENT
// Load link register
  l         gp,0x08(stkp)
  mtlr      gp
// Return
  br

/*===============*/
/*END OF FUNCTION*/
