#ifndef __STACK
#define __STACK

/* Register definition:
   gpr1 	stkp
   gpr2 	general (no needed to be saved data can be in here)
   gpr3-31	data (saved and restored over function calls)
*/
/*
  Stack definition:
    This is probably not conventional, but it'll work for now  
  
  stack decrement is always 20 long words, 80 bytes.
  The current stack pointer points to a pointer pointing
  to the previous stack pointer position.
  First instruction in any routine is to save the link register
  contents to the special slot allocated to it as 0x4 above the 
  current stack pointer.
  Next the stack pointer is changed and then the contents of 
  registers that are about to be used are saved to the stack.
  In a function call the arguments are placed in the current
  stack context and a pointer to the first (lowest address)
  is placed in register 3
*/

#define STKP_DECREMENT -0x50
#define STKP_INCREMENT  0x50

#endif /*__STACK*/
